<template>
  <AccordionFieldset label="Informations générales">
    <div class="fr-container--fluid">
      <div class="fr-grid-row fr-grid-row--gutters form-grid">
        <AtomSelect
          v-model="status"
          name="status"
          class="fr-col-12"
          label="Statut du dossier"
          :options="STATUS_OPTIONS"
          required
        />
        <AtomSelect
          name="title"
          label="Civilité"
          :options="withEmptyValue(TITLE_OPTIONS)"
          :model-value="beneficiary?.title || ''"
        />
        <AtomInput
          name="usual_name"
          label="Nom usuel"
          :value="beneficiary?.usual_name || ''"
        />
        <AtomInput
          name="birth_name"
          label="Nom de naissance"
          :value="beneficiary?.birth_name || ''"
        />
        <AtomInput
          name="firstname"
          label="Prénom(s)"
          :value="beneficiary?.firstname || ''"
        />
        <AtomInput
          name="birthdate"
          label="Date de naissance"
          type="date"
          :value="beneficiary?.birthdate || ''"
        />
        <AtomInput
          name="birth_place"
          label="Lieu de naissance"
          :value="beneficiary?.birth_place || ''"
        />
        <AtomInput
          v-show="isDeceased"
          name="deathdate"
          label="Date de décès"
          type="date"
          :value="beneficiary?.deathdate || ''"
        />
        <AtomSelect
          name="gender"
          label="Genre"
          :options="withEmptyValue(GENDER_OPTIONS)"
          :model-value="beneficiary?.gender || ''"
        />
        <AtomSelect
          :class="{
            'fr-col-offset-lg-4--right': !isDeceased && !isMinistryAgent
          }"
          name="nationality"
          label="Nationalité"
          :options="withEmptyValue(NATIONALITY_OPTIONS)"
          :model-value="beneficiary?.nationality || ''"
        />
        <AtomInput
          v-if="isMinistryAgent"
          name="numero_pegase"
          label="Numéro Pégase"
          :value="beneficiary?.numero_pegase || ''"
        />
        <AtomSelect
          v-model="accommodationMode"
          class="fr-col-12"
          :class="{ 'fr-col-lg-6': isHosted }"
          name="accommodation_mode"
          label="Mode d'hébergement"
          :options="withEmptyValue(ACCOMMODATION_MODE_OPTIONS)"
        />
        <AtomInput
          v-show="isHosted"
          class="fr-col-12 fr-col-lg-6"
          name="accommodation_name"
          :label="accommodationNameLabel"
          :value="beneficiary?.accommodation_name || ''"
        />
        <AtomInput
          class="fr-col-12"
          name="accommodation_additional_information"
          label="Précisions hébergement"
          :value="beneficiary?.accommodation_additional_information || ''"
        />
        <AtomInput
          name="zip_code"
          label="Code postal"
          :value="zipCode"
          @change-value="zipCode = $event"
        />
        <AtomCityInput
          label="Ville"
          name="city"
          :value="city"
          :zip-code="zipCode"
          @city-selected="updateCity"
        />
        <AtomRegionInput
          label="Région"
          name="region"
          :value="region"
          @region-selected="region = $event"
        />
        <AtomSelect
          v-if="isMinistryAgent"
          class="fr-col-12"
          name="accommodation_zone"
          label="Zone d'hébergement"
          :model-value="beneficiary?.accommodation_zone || ''"
          :options="withEmptyValue(ACCOMMODATION_ZONE_OPTIONS)"
        />
        <AtomInput
          class="fr-col-12 fr-col-lg-2"
          name="street_number"
          label="Numéro"
          :value="beneficiary?.street_number || ''"
        />
        <AtomAddressInput
          class="fr-col-12 fr-col-lg-10"
          name="street"
          label="Rue"
          :value="beneficiary?.street || ''"
          :zip-code="zipCode"
          @address-selected="updateCity"
        />
        <AtomInput
          class="fr-col-12"
          name="address_complement"
          label="Complément d'adresse"
          :value="beneficiary?.address_complement || ''"
          hint="Bâtiment, immeuble, escalier et numéro d’appartement"
        />
        <AtomCheckbox
          v-model="noPhone"
          label="N'a pas de téléphone"
          name="no_phone"
        />
        <AtomInput
          v-show="!noPhone"
          name="phone_1"
          label="Téléphone 1"
          type="tel"
          :value="noPhone ? '' : phone1"
        />
        <AtomInput
          v-show="!noPhone"
          name="phone_2"
          label="Téléphone 2"
          type="tel"
          :value="noPhone ? '' : phone2"
        />
        <AtomInput
          name="email"
          label="Email"
          type="email"
          :value="beneficiary?.email || ''"
        />
        <AtomCheckbox
          class="caregiver-checkbox"
          label="Aidant familial"
          name="caregiver"
          :model-value="beneficiary && beneficiary.caregiver"
        />
        <AtomSelect
          class="fr-col-12"
          name="mobility"
          label="Données mobilité"
          :model-value="beneficiary?.mobility || ''"
          :options="withEmptyValue(MOBILITY_MODE_OPTIONS)"
        />
      </div>
    </div>
  </AccordionFieldset>
</template>

<script setup>
  import {
    HOSTING_ACCOMMODATION_MODE_VALUES,
    ORGANISATION_ACCOMMODATION_MODE_VALUES,
    THIRD_PARTY_ACCOMMODATION_MODE_VALUES,
    DECEASED_STATUS_VALUE,
    STATUS_OPTIONS,
    TITLE_OPTIONS,
    GENDER_OPTIONS,
    ACCOMMODATION_MODE_OPTIONS,
    MOBILITY_MODE_OPTIONS,
    ACCOMMODATION_ZONE_OPTIONS
  } from '~/utils/constants/beneficiary'
  import { NATIONALITY_OPTIONS } from '~/utils/constants/nationalities'
  import { withEmptyValue } from '~/utils'
  import { errorResponseMessage } from '~~/utils/errorResponse'

  const { $request } = useNuxtApp()
  const isMinistryAgent = useMinistryAgent()

  const props = defineProps({
    beneficiary: { type: Object, default: null }
  })

  const accommodationMode = ref(props.beneficiary?.accommodation_mode)
  const zipCode = ref(props.beneficiary?.zip_code)
  const city = ref(props.beneficiary?.city)
  const status = ref(props.beneficiary?.status)
  const noPhone = ref(props.beneficiary?.no_phone)
  const phone1 = ref(props.beneficiary?.phone_1)
  const phone2 = ref(props.beneficiary?.phone_)
  const region = ref(props.beneficiary?.region)

  const isHosted = computed(() =>
    HOSTING_ACCOMMODATION_MODE_VALUES.includes(accommodationMode.value)
  )

  const accommodationNameLabel = computed(() => {
    if (
      ORGANISATION_ACCOMMODATION_MODE_VALUES.includes(accommodationMode.value)
    ) {
      return 'Dénomination de la structure'
    }
    if (
      THIRD_PARTY_ACCOMMODATION_MODE_VALUES.includes(accommodationMode.value)
    ) {
      return 'Nom et prénom du tiers'
    }
    return ''
  })

  const isDeceased = computed(() => status.value === DECEASED_STATUS_VALUE)

  async function updateCity({
    codeRegion,
    zipCode: _zipCode,
    city: _city,
    region: _region
  }) {
    if (codeRegion) region.value = await codeRegionToRegionName(codeRegion)
    if (_region) region.value = _region
    zipCode.value = _zipCode
    city.value = _city
  }

  async function codeRegionToRegionName(codeRegion) {
    try {
      const res = await $request(
        `https://geo.api.gouv.fr/regions/${codeRegion}`
      )

      if (res.status === 200) return res.data.nom
      throw new Error(errorResponseMessage(res))
    } catch {
      return ''
    }
  }
</script>

<style scoped>
  .caregiver-checkbox {
    align-self: center;
  }
</style>
